*+--------------------------------------------------------------------
*+
*+ Source Module => c:\hmg.3.4.4\0\PBSTACK\\PBSTACK.PRG
*+
*+    Copyright(C) 1983-2020 by Auge & Ohr
*+
*+    Functions: Procedure MAIN()
*+               Procedure InitPbStack()
*+               Procedure AskEndApp()
*+               Procedure LBaction()
*+               Static Function Test()
*+               Procedure SwitchPB()
*+
*+    Reformatted by Click! 2.05.30 on Jul-2-2020 at 12:45 am
*+
*+--------------------------------------------------------------------

#include "HMG.CH"

#define ID_TEXT      1
#define ID_ACTION    2

STATIC nActivPB := 1

*+--------------------------------------------------------------------
*+
*+    Procedure MAIN()
*+
*+--------------------------------------------------------------------
*+
PROCEDURE MAIN

LOCAL aButtons := { ;
                       { 'Button F1', ;
                       { { 'Text 1,1', { || Test( 1, 1 ) } }, ;
                       { 'Text 1,2', { || Test( 1, 2 ) } }, ;
                       { 'Text 1,3', { || Test( 1, 3 ) } } } }, ;
                       { 'Button F2', ;
                       { { 'Text 2,1', { || Test( 2, 1 ) } }, ;
                       { 'Text 2,2', { || Test( 2, 2 ) } } } }, ;
                       { 'Button F3', ;
                       { { 'Text 3,1', { || Test( 3, 1 ) } }, ;
                       { 'Text 3,2', { || Test( 3, 2 ) } }, ;
                       { 'Text 3,3', { || Test( 3, 3 ) } }, ;
                       { 'Text 3,4', { || Test( 3, 4 ) } } } }, ;
                       { 'Button F4', ;
                       { { 'Text 4,1', { || Test( 4, 1 ) } }, ;
                       { 'Text 4,2', { || Test( 4, 2 ) } }, ;
                       { 'Text 4,3', { || Test( 4, 3 ) } } } }, ;
                       { 'Button F5', ;
                       { { 'Text 5,1', { || Test( 5, 1 ) } }, ;
                       { 'Text 5,2', { || Test( 5, 2 ) } }, ;
                       { 'Text 5,3', { || Test( 5, 3 ) } } } }, ;
                       { 'Button F6', ;
                       { { 'Text 6,1', { || Test( 6, 1 ) } }, ;
                       { 'Text 6,2', { || Test( 6, 2 ) } }, ;
                       { 'Text 6,3', { || Test( 6, 3 ) } } } }, ;
                       { 'Button F7', ;
                       { { 'Text 7,1', { || Test( 7, 1 ) } }, ;
                       { 'Text 7,2', { || Test( 7, 2 ) } }, ;
                       { 'Text 7,3', { || Test( 7, 3 ) } } } }, ;
                       { 'Button F8', ;
                       { { 'Text 8,1', { || Test( 8, 1 ) } }, ;
                       { 'Text 8,2', { || Test( 8, 2 ) } }, ;
                       { 'Text 8,3', { || Test( 8, 3 ) } } } }, ;
                       { 'Button F9', ;
                       { { 'Text 9,1', { || Test( 9, 1 ) } }, ;
                       { 'Text 9,2', { || Test( 9, 2 ) } }, ;
                       { 'Text 9,3', { || Test( 9, 3 ) } } } }, ;
                       { 'Button F10', ;
                       { { 'Text 10,1', { || Test( 10, 1 ) } } } }, ;
                       { 'Button F11', ;
                       { { 'Exit', { || AskEndApp() } } } } }

   DEFINE WINDOW PbForm ;
              AT 0, 0    ;
              WIDTH 1024 ;
              HEIGHT 768 ;
              TITLE "PbStack" ;
              ICON NIL ;
              ON INIT Nil ;
              ON RELEASE Nil ;
              ON SIZE Nil ;
              ON MAXIMIZE Nil ;
              ON MINIMIZE Nil ;
              ON PAINT Nil ;
              BACKCOLOR Nil

      DEFINE LISTBOX List_1
         ROW 0
         COL 0
         WIDTH 120
         HEIGHT 400
         ITEMS {}
         VALUE 0
         FONTNAME "Arial"
         FONTSIZE 18
         TOOLTIP ""
         ONCHANGE Nil
         ONGOTFOCUS Nil
         ONLOSTFOCUS Nil
         FONTBOLD .F.
         FONTITALIC .F.
         FONTUNDERLINE .F.
         FONTSTRIKEOUT .F.
         BACKCOLOR NIL
         FONTCOLOR NIL
         ONDBLCLICK LBaction( This.Value, aButtons )
         HELPID Nil
         TABSTOP .T.
         VISIBLE .T.
         SORT .F.
         MULTISELECT .F.
         DRAGITEMS .F.
      END LISTBOX

      DEFINE BUTTON Button_1
         ROW 400
         COL 0
         CAPTION "F1"
         PICTURE Nil
         PICTALIGNMENT TOP
         ONCLICK SwitchPB( 1, @aButtons )
         WIDTH 120
         HEIGHT 30
         FONTNAME "Arial"
         FONTSIZE 9
         FONTBOLD .F.
         FONTITALIC .F.
         FONTUNDERLINE .F.
         FONTSTRIKEOUT .F.
         TOOLTIP ""
         FLAT .F.
         TRANSPARENT .F.
         ONGOTFOCUS Nil
         ONLOSTFOCUS Nil
         TABSTOP .T.
         HELPID Nil
         VISIBLE .T.
         MULTILINE .F.
      END BUTTON

      DEFINE BUTTON Button_2
         ROW 430
         COL 0
         CAPTION "F2"
         PICTURE Nil
         PICTALIGNMENT TOP
         ONCLICK SwitchPB( 2, @aButtons )
         WIDTH 120
         HEIGHT 30
         FONTNAME "Arial"
         FONTSIZE 9
         FONTBOLD .F.
         FONTITALIC .F.
         FONTUNDERLINE .F.
         FONTSTRIKEOUT .F.
         TOOLTIP ""
         FLAT .F.
         TRANSPARENT .F.
         ONGOTFOCUS Nil
         ONLOSTFOCUS Nil
         TABSTOP .T.
         HELPID Nil
         VISIBLE .T.
         MULTILINE .F.
      END BUTTON

      DEFINE BUTTON Button_3
         ROW 460
         COL 0
         CAPTION "F3"
         PICTURE Nil
         PICTALIGNMENT TOP
         ONCLICK SwitchPB( 3, @aButtons )
         WIDTH 120
         HEIGHT 30
         FONTNAME "Arial"
         FONTSIZE 9
         FONTBOLD .F.
         FONTITALIC .F.
         FONTUNDERLINE .F.
         FONTSTRIKEOUT .F.
         TOOLTIP ""
         FLAT .F.
         TRANSPARENT .F.
         ONGOTFOCUS Nil
         ONLOSTFOCUS Nil
         TABSTOP .T.
         HELPID Nil
         VISIBLE .T.
         MULTILINE .F.
      END BUTTON

      DEFINE BUTTON Button_4
         ROW 490
         COL 0
         CAPTION "F4"
         PICTURE Nil
         PICTALIGNMENT TOP
         ONCLICK SwitchPB( 4, @aButtons )
         WIDTH 120
         HEIGHT 30
         FONTNAME "Arial"
         FONTSIZE 9
         FONTBOLD .F.
         FONTITALIC .F.
         FONTUNDERLINE .F.
         FONTSTRIKEOUT .F.
         TOOLTIP ""
         FLAT .F.
         TRANSPARENT .F.
         ONGOTFOCUS Nil
         ONLOSTFOCUS Nil
         TABSTOP .T.
         HELPID Nil
         VISIBLE .T.
         MULTILINE .F.
      END BUTTON

      DEFINE BUTTON Button_5
         ROW 520
         COL 0
         CAPTION "F5"
         PICTURE Nil
         PICTALIGNMENT TOP
         ONCLICK SwitchPB( 5, @aButtons )
         WIDTH 120
         HEIGHT 30
         FONTNAME "Arial"
         FONTSIZE 9
         FONTBOLD .F.
         FONTITALIC .F.
         FONTUNDERLINE .F.
         FONTSTRIKEOUT .F.
         TOOLTIP ""
         FLAT .F.
         TRANSPARENT .F.
         ONGOTFOCUS Nil
         ONLOSTFOCUS Nil
         TABSTOP .T.
         HELPID Nil
         VISIBLE .T.
         MULTILINE .F.
      END BUTTON

      DEFINE BUTTON Button_6
         ROW 550
         COL 0
         CAPTION "F6"
         PICTURE Nil
         PICTALIGNMENT TOP
         ONCLICK SwitchPB( 6, @aButtons )
         WIDTH 120
         HEIGHT 30
         FONTNAME "Arial"
         FONTSIZE 9
         FONTBOLD .F.
         FONTITALIC .F.
         FONTUNDERLINE .F.
         FONTSTRIKEOUT .F.
         TOOLTIP ""
         FLAT .F.
         TRANSPARENT .F.
         ONGOTFOCUS Nil
         ONLOSTFOCUS Nil
         TABSTOP .T.
         HELPID Nil
         VISIBLE .T.
         MULTILINE .F.
      END BUTTON

      DEFINE BUTTON Button_7
         ROW 580
         COL 0
         CAPTION "F7"
         PICTURE Nil
         PICTALIGNMENT TOP
         ONCLICK SwitchPB( 7, @aButtons )
         WIDTH 120
         HEIGHT 30
         FONTNAME "Arial"
         FONTSIZE 9
         FONTBOLD .F.
         FONTITALIC .F.
         FONTUNDERLINE .F.
         FONTSTRIKEOUT .F.
         TOOLTIP ""
         FLAT .F.
         TRANSPARENT .F.
         ONGOTFOCUS Nil
         ONLOSTFOCUS Nil
         TABSTOP .T.
         HELPID Nil
         VISIBLE .T.
         MULTILINE .F.
      END BUTTON

      DEFINE BUTTON Button_8
         ROW 610
         COL 0
         CAPTION "F8"
         PICTURE Nil
         PICTALIGNMENT TOP
         ONCLICK SwitchPB( 8, @aButtons )
         WIDTH 120
         HEIGHT 30
         FONTNAME "Arial"
         FONTSIZE 9
         FONTBOLD .F.
         FONTITALIC .F.
         FONTUNDERLINE .F.
         FONTSTRIKEOUT .F.
         TOOLTIP ""
         FLAT .F.
         TRANSPARENT .F.
         ONGOTFOCUS Nil
         ONLOSTFOCUS Nil
         TABSTOP .T.
         HELPID Nil
         VISIBLE .T.
         MULTILINE .F.
      END BUTTON

      DEFINE BUTTON Button_9
         ROW 640
         COL 0
         CAPTION "F9"
         PICTURE Nil
         PICTALIGNMENT TOP
         ONCLICK SwitchPB( 9, @aButtons )
         WIDTH 120
         HEIGHT 30
         FONTNAME "Arial"
         FONTSIZE 9
         FONTBOLD .F.
         FONTITALIC .F.
         FONTUNDERLINE .F.
         FONTSTRIKEOUT .F.
         TOOLTIP ""
         FLAT .F.
         TRANSPARENT .F.
         ONGOTFOCUS Nil
         ONLOSTFOCUS Nil
         TABSTOP .T.
         HELPID Nil
         VISIBLE .T.
         MULTILINE .F.
      END BUTTON

      DEFINE BUTTON Button_10
         ROW 670
         COL 0
         CAPTION "F10"
         PICTURE Nil
         PICTALIGNMENT TOP
         ONCLICK SwitchPB( 10, @aButtons )
         WIDTH 120
         HEIGHT 30
         FONTNAME "Arial"
         FONTSIZE 9
         FONTBOLD .F.
         FONTITALIC .F.
         FONTUNDERLINE .F.
         FONTSTRIKEOUT .F.
         TOOLTIP ""
         FLAT .F.
         TRANSPARENT .F.
         ONGOTFOCUS Nil
         ONLOSTFOCUS Nil
         TABSTOP .T.
         HELPID Nil
         VISIBLE .T.
         MULTILINE .F.
      END BUTTON

      DEFINE BUTTON Button_11
         ROW 700
         COL 0
         CAPTION "F11"
         PICTURE Nil
         PICTALIGNMENT TOP
         ONCLICK SwitchPB( 11, @aButtons )
         WIDTH 120
         HEIGHT 30
         FONTNAME "Arial"
         FONTSIZE 9
         FONTBOLD .F.
         FONTITALIC .F.
         FONTUNDERLINE .F.
         FONTSTRIKEOUT .F.
         TOOLTIP ""
         FLAT .F.
         TRANSPARENT .F.
         ONGOTFOCUS Nil
         ONLOSTFOCUS Nil
         TABSTOP .T.
         HELPID Nil
         VISIBLE .T.
         MULTILINE .F.
      END BUTTON
   END WINDOW

   SwitchPB( 1, @aButtons )

   ON KEY ESCAPE OF PbForm ACTION PbForm.Release
   CENTER WINDOW PbForm
   PbForm.Button_1.setfocus()
   ACTIVATE WINDOW PbForm

RETURN

*+--------------------------------------------------------------------
*+
*+    Procedure InitPbStack()
*+
*+--------------------------------------------------------------------
*+
PROCEDURE InitPbStack()

RETURN

*+--------------------------------------------------------------------
*+
*+    Procedure AskEndApp()
*+
*+    Called from ( pbstack.prg )   1 - procedure main()
*+
*+--------------------------------------------------------------------
*+
PROCEDURE AskEndApp()

   IF MsgYesNo( "end App now", "Ende" )
      PbForm.Release
   ENDIF
RETURN

*+--------------------------------------------------------------------
*+
*+    Procedure LBaction()
*+
*+    Called from ( pbstack.prg )   1 - procedure main()
*+
*+--------------------------------------------------------------------
*+
PROCEDURE LBaction( nNo, aButtons )

LOCAL cCB
   cCB := aButtons[ nActivPB ] [ 2 ] [ nNo ] [ ID_ACTION ]
   EVAL( cCB )
RETURN

*+--------------------------------------------------------------------
*+
*+    Static Function Test()
*+
*+    Called from ( pbstack.prg )  28 - procedure main()
*+
*+--------------------------------------------------------------------
*+
STATIC FUNCTION Test( nRow, nCol )

   MsgInfo( "This is " + ALLTRIM( STR( nRow ) ) + "," + ALLTRIM( STR( nCol ) ) )
RETURN nil

*+--------------------------------------------------------------------
*+
*+    Procedure SwitchPB()
*+
*+    Called from ( pbstack.prg )  12 - procedure main()
*+
*+--------------------------------------------------------------------
*+
PROCEDURE SwitchPB( nNo, aButtons )

LOCAL ii, iMax, aItems, cText, cButton
LOCAL nRow := 0

   IF nNo <= LEN( aButtons )
      nActivPB := nNo
      PbForm.List_1.DeleteAllItems

      ii := 1
      FOR ii := 1 TO nNo
         cButton := "Button_" + LTRIM( STR( ii ) )
         SetProperty( "PbForm", cButton, "ROW", nRow )
         nRow += 30
      NEXT

      SetProperty( "PbForm", "List_1", "ROW", nRow )
      nRow += GetProperty( "PbForm", "List_1", "HEIGHT" )
      // nRow += 400

      ii := 1
      FOR ii := nNo + 1 TO LEN( aButtons )
         cButton := "Button_" + LTRIM( STR( ii ) )
         SetProperty( "PbForm", cButton, "ROW", nRow )
         nRow += 30
      NEXT

      aItems := aButtons[ nNo ] [ 2 ]
      iMax := LEN( aItems )
      ii := 1
      FOR ii := 1 TO iMax
         cText := aItems[ ii ] [ ID_TEXT ]
         PbForm.List_1.AddItem( cText )
      NEXT

   ELSE
      MsgInfo( "Error " + LTRIM( STR( nNo ) ) + " of " + LTRIM( STR( LEN( aButtons ) ) ) )
   ENDIF
RETURN

//
//
//

*+ EOF: PBSTACK.PRG